import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

import "Kiki.SuperChrono.UTF";
import "Kiki.SuperChrono.Languages";
import "Kiki.SuperChrono.Class";
import "Kiki.SuperChrono.Settings";
import "Kiki.SuperChrono.Includes.ChatLogger";
import "Kiki.SuperChrono.Includes.OnScreen";
import "Kiki.SuperChrono.Includes.DateUtils";
import "Kiki.SuperChrono.Includes.NumberUtils";
import "Kiki.SuperChrono.Includes.StringUtils";
import "Kiki.SuperChrono.Windows.Log";
import "Kiki.SuperChrono.Windows.Chrono";
import "Kiki.SuperChrono.Windows.Maj";
import "Kiki.SuperChrono.Windows.Export";


dragBarAvailable = pcall( function(sender,args)
	import "Deusdictum.UI.DragBar";
end );



--Plugin Starts Here

-- Dump table function for checking tables on the fly ---------------
function dump(o)
    if type(o) == 'table' then
        local s = '{\n'
        for k,v in pairs(o) do
                if type(k) ~= 'number' then k = '"'..k..'"' end
                s = s .. '['..k..'] = ' .. dump(v) .. '\n'
        end
        return s .. '}\n'
    else
        return tostring(o)
    end
end


--This function returns a deep copy of a given table ---------------
function deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end


-- This function merges table two into table one, overwriting any matching entries.
function mergeTables(t1, t2)
	for k, v in pairs(t2) do
		if (type(v) == "table") and (type(t1[k] or false) == "table") then
			mergeTables(t1[k], t2[k])
		else
			t1[tostring(k)] = v
		end
	end
	return t1
end

-- Recupere la langue du client
function getClientLanguage()
	
	if Turbine.Shell.IsCommand("hilfe") then
		return "GERMAN";
	elseif Turbine.Shell.IsCommand("aide") then
		return "FRENCH";
	else 
		return "ENGLISH";
	end
end



-- sauvegarde des settings
function saveSettings()
	Settings.Save();
	Includes.Trace("Warm data saved");
end

-- Unload du plugin
Turbine.Plugin.Unload = function (sender, args)
	saveSettings();
	Includes.Trace("unloaded");
end


RESOURCESDIR = "Kiki/SuperChrono/Resources/";
SETTINGSVERSION = "1.0";

gSettings = Settings.Load();

-- override le nom du plgin
gSettings.pluginName = "SuperChrono";
-- Override la langue
gSettings.lang = getClientLanguage();

-- Charge les traductions
gLang = getLang(gSettings.lang); 

-- Charge le joueur actuel
gPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
gName = gPlayer:GetName();

-- Affiche la fenetre de logs
Windows.DrawLogWindow();
Windows.DrawChronoWindow();
Windows.wMajDraw();

-- En cas Includes.Trace(hangement de l'etat de combat
gPlayer.InCombatChanged = function(sender, args)
	Windows.SetBarInCombat(gPlayer:IsInCombat());
end

-- Traqueur de messages
Includes.InitiateChatLogger();


-- Si une config est indique dans les settings, on la charge initialement
if gSettings.lastConfigName ~= nil then
	Windows.ChronoActivateConfigurationByName(gSettings.lastConfigName);
end

-- commands
scCommand = Turbine.ShellCommand();
Turbine.Shell.AddCommand("sc", scCommand);
Turbine.Shell.AddCommand("SuperChrono", scCommand);
function scCommand:GetShortHelp()
    return gLang.USAGE;
end
function scCommand:GetHelp()
    return self:GetShortHelp();
end
function scCommand:Execute(cmd, args)
	Windows.wChronoParent:SetVisible(not Windows.wChronoParent:IsVisible());
end

-- Retrouve la version du plugin
Includes.Trace("loaded (version ".. Plugins["SuperChrono"]:GetVersion() .. " by Kikiadoc@Sirannon)");
Includes.Trace(gLang.USAGE);

-- Includes.Trace(dump(gSettings));













