-- gestionnaire des chronometres

chronoAvecEvent = { START=0; ORANGE=1; RED=2; LOOP=3; RESET=4 };

chronoWidth = 200;
chronoHeight = 60;
chronoLineHeight = 17;
chronoBtnWidth = 20;	-- taille,  droite, du bouton dans le chrono (les rouages)
chronoStdHeight= 20;	-- hauteur standard d'un element de la fenetre de chrono

ChronoConfig = { name=nil; chronos= {} };

-- Struture d'un chrono:
	-- Lbl est le libelle qui s'affiche dans la liste des chronos
	-- comment est un commentaire de description du compteur
	-- Texte est le texte  traquer et qui dclenche le chrono
	-- warn est le delai avant passage en orange, alert, le passage en rouge
	-- reset est le delai qui va faire repasser le chrono  l'etat initial (gris, en attente d'un message)
	-- boucle  est le delai qui doit entrainer le rebouclage du chrono et valBoucle est la valeur  positionner lors de la boucle
	-- control est la reference sur le control associe dans la fenetre des chronos
	-- status indique le status actuel
	--		0 pour indiquer un "gris" (pas de message pour l'instant)
	--		1 pour indiquer message actif
-------------------------------------------------------------------------------------------------------------------------------



function DrawChronoWindow()

	if wChronoParent == nil then
	
		-- wChronoParent = class( Turbine.UI.Window );
		wChronoParent = Turbine.UI.Window();
		
		wChronoParent:SetPosition(gSettings.chrono.x,gSettings.chrono.y);
        wChronoParent:SetSize(chronoWidth,chronoHeight);
        -- wChronoParent:SetBackColor(Turbine.UI.Color(0, 0, 1));
        -- Includes.Trace(RESOURCESDIR.."anchor.tga");
        wChronoParent:SetBackground(RESOURCESDIR.."anchor.tga");

		Includes.Onscreen(wChronoParent);
		
		-- Comportement standard lotro pour la fenetre
		if dragBarAvailable == true then
			Includes.Trace("Dragbar available");
			wChronoParent.DragBar = Deusdictum.UI.DragBar( wChronoParent, "SuperChrono" );
		else
			Includes.Trace("Dragbar not available");
		end
		--
		
		
		wChronoParent.PositionChanged = function()
			gSettings.chrono.x = wChronoParent:GetLeft();
			gSettings.chrono.y = wChronoParent:GetTop();
		end
    	--	
	    	
		wChronoParent.MouseDown = function (sender, args)
			-- Includes.Trace("mouseDown:"..args.X..","..args.Y);
			wcDRAGGING = true;
			wcRelX = args.X;
			wcRelY = args.Y;
		end
	
		wChronoParent.MouseUp = function (sender, args)
			if wcDRAGGING then
				wcDRAGGING = false;
				if dragBarAvailable then
					wChronoParent.DragBar:Refresh();
				end
			end
		end
	
		wChronoParent.MouseMove = function (sender, args)
			if wcDRAGGING == true then
				local scX = Turbine.UI.Display.GetMouseX();
				local scY = Turbine.UI.Display.GetMouseY();
				local pX = scX - wcRelX;
				local pY= scY - wcRelY;
	
				if pX < 0 then pX = 0 end
				-- if pX > (SCREENWIDTH-32) then SETTINGS.ICONX = (SCREENWIDTH-32) end
				if pY < 0 then pY = 0 end
				-- if pY > (SCREENHEIGHT-32) then SETTINGS.ICONY = (SCREENHEIGHT-32) end
	
				wChronoParent:SetPosition(pX,pY);
			end
		end
    	
      	ChronoActiveConfig = Turbine.UI.TextBox();
      	ChronoActiveConfig:SetPosition( 0 , 0 );
      	ChronoActiveConfig:SetSize( chronoWidth - 65, chronoStdHeight );
      	ChronoActiveConfig:SetParent( wChronoParent );
		ChronoActiveConfig:SetBackColor(Turbine.UI.Color( 0.2,0,0));
		ChronoActiveConfig:SetForeColor(Turbine.UI.Color( 1,1,1));
		ChronoActiveConfig:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		ChronoActiveConfig:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		ChronoActiveConfig:SetText("");
		ChronoActiveConfig:SetMultiline(false);
		ChronoActiveConfig:SetEnabled(false);
		ChronoActiveConfig.FocusGained = function (sender, args)
			ChronoActiveConfig:SetWantsKeyEvents(true);
		end
		ChronoActiveConfig.FocusLost = function (sender, args)
			ChronoActiveConfig:SetWantsKeyEvents(false);
			local t = string.sub(ChronoActiveConfig:GetText(),1,20);
			ChronoActiveConfig:SetText(t);
			ChronoConfig.name = t;
			table.sort(gSettings.configurations, function(p1, p2) return p1.name < p2.name end );
			saveSettings();
		end
		
		
		---- UTILITE DE CETE SEQUENCE ????? (on clique dans le texte pour le modifier....)
		ChronoActiveConfig.KeyDown = function (sender, args)
			-- Includes.Trace("kdo="..dump(args));
			if args.Action==162 then
				-- touche ENTER
				ChronoActiveConfig:SetWantsKeyEvents(false);
				BarInCombat:Focus();
			end
		end
      	
      	ChronoActions = Turbine.UI.Lotro.Button();
      	ChronoActions:SetPosition( chronoWidth - 65 , 0 );
      	ChronoActions:SetSize( 50, chronoStdHeight );
      	ChronoActions:SetParent( wChronoParent );
		ChronoActions:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		ChronoActions:SetText(gLang.ACTIONS);
		
		-- Activation du menu contextuel
		ChronoActions.Click = function( sender, args)
	       -- Display the menu at the current mouse location.
	       ChronoDisplayContextMenu();
		end

      	BarInCombat = Turbine.UI.Button();	
      	BarInCombat:SetPosition( 0 , chronoStdHeight );
      	BarInCombat:SetSize( chronoWidth, chronoStdHeight-2 );
      	BarInCombat:SetParent( wChronoParent );
		-- BarInCombat:SetBackColor(Turbine.UI.Color( 0.4, 0.4, 0.4 ));
		BarInCombat:SetBackground(RESOURCESDIR.."grey.tga");
		
		BarInCombat:SetForeColor(Turbine.UI.Color( 0,0,0));
		BarInCombat:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		BarInCombat:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

      	-- SelfInMsg = Turbine.UI.Button();	
      	-- SelfInMsg:SetPosition( 0 , 2*chronoStdHeight );
      	-- SelfInMsg:SetSize( chronoWidth, chronoStdHeight-2 );
      	-- SelfInMsg:SetParent( wChronoParent );
		-- SelfInMsg:SetBackColor(Turbine.UI.Color( 0.4, 0.4, 0.4 ));
		-- SelfInMsg:SetForeColor(Turbine.UI.Color( 0,0,0));
		-- SelfInMsg:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		-- SelfInMsg:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		-- SelfInMsg:SetText("0:00:00 *N/A* "..gName);


		ChronoList = Turbine.UI.ListBox();
		ChronoList:SetPosition(0, 2*chronoStdHeight);
		ChronoList:SetParent(wChronoParent);

		-- Rafraichit la liste des chronos
		ChronoUpdateList();
		
		wChronoParent:SetWantsUpdates(true);
		wChronoParent.Update = function( sender, args )
			-- mise  jour tous les 2/10 de secondes seulement
			local n = math.floor(Turbine.Engine.GetGameTime()*10);
			if wChronoLastTimeStamp ~= n then
				wChronoLastTimeStamp = n;
				ChronoRefreshAll();
			end
		end

		-- Init parameters		
		SetBarInCombat(Turbine.Gameplay.LocalPlayer.GetInstance().IsInCombat());
		ChronoActiveConfig:SetText(gConfigName);
		wChronoParent:SetVisible(true);
	end
end

function ChronoUpdateList()
		-- Balayer les infos de ChronoConfig.chronos pour afficher les barres de controles des chronos
		ChronoList:ClearItems();
		for i=1, # ChronoConfig.chronos do
			ChronoAdd(ChronoConfig.chronos[i]);
		end
		ChronoSizeRefresh();
end

---- Recupere la position dans la liste des chronos
function ChronoGetPosition(chrono)
	for i=1, #ChronoConfig.chronos do
		if ChronoConfig.chronos[i] == chrono then return i; end
	end
	return nil;
end
--- Deplace un chrono vers le haut
function ChronoHaut(chrono)
	local i = ChronoGetPosition(chrono);
	if i ~= nil and i > 1 then
		local save = ChronoConfig.chronos[i-1];
		ChronoConfig.chronos[i-1] = chrono;
		ChronoConfig.chronos[i] = save;
		ChronoList:RemoveItem(chrono.bck);
		ChronoList:InsertItem(i-1,chrono.bck);
	end
end
--- Deplace un chrono vers le base
function ChronoBas(chrono)
	local i = ChronoGetPosition(chrono);
	if i ~= nil and i < #ChronoConfig.chronos then
		local save = ChronoConfig.chronos[i+1];
		ChronoConfig.chronos[i+1] = chrono;
		ChronoConfig.chronos[i] = save;
		ChronoList:RemoveItem(chrono.bck);
		ChronoList:InsertItem(i+1,chrono.bck);
	end
end


-- Creation d'un chronometre "vide"
function ChronoDefault()
	return { 
					lbl= gLang.LBLHELP; 
					comment=gLang.COMMENTHELP;
					search=""; -- gLang.SEARCHHELP;
					warn=-1; alert=-1; reset=0; loop=0; loopVal = 0;
					demarreAvec="";
					demarreCombat=false;
					resetCombat=false;
					control= nil;
					bar=nil;  
					status=0; 
					dth=0;
					lastDelta=-1;
					isCountdown=false;
					isBlinkOra=false;
					isBlinkRed=false;
					starting=false;
					clickDelay=0;
					combatDelay=0;
					searchDelay=0;
					avecDelay=0;
					combatOnce=false;
					searchOnce=false;
					avecOnce=false;
					avecEvent=chronoAvecEvent.START;
			 };
end

-- Definit et insert un chrono dans la config active avec un texte de recherche eventuel
function ChronoNew(s)
	if (ChronoConfig.name == nil) then return end;
	local c =	ChronoDefault();
	if  s ~= nil then
		c.lbl = "*TBD*" .. string.sub(s,1,10);
		c.search = s; 
	end
	ChronoInsert(c);
end

-- Ajoute un chrono dans la liste des chronos de la confi active
function ChronoInsert(c)
	table.insert(ChronoConfig.chronos,c);
	ChronoAdd(c);
	ChronoSizeRefresh();
end

--Ajout d'un chronometre
function ChronoAdd(chrono)
	local bck = Turbine.UI.Control();
	bck:SetSize(chronoWidth, chronoStdHeight);
	local gry = Turbine.UI.Control();
	gry:SetBackground(RESOURCESDIR.."greyCounter.tga");
	gry:SetSize( chronoWidth, chronoStdHeight-2);
	gry:SetParent(bck);
	
	local bar = Turbine.UI.Control();
	bar:SetSize( 0, 18 );
	bar:SetParent(bck);
	
	local btn = Turbine.UI.Button();
	btn:SetSize( chronoWidth, 18 );
	btn:SetZOrder(1000); 
	btn:SetParent(bck);

	btn:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	btn:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	btn:SetVisible(true);

	chrono.control = btn;
	chrono.bar = bar;
	chrono.bck = bck;


	btn.MouseClick = function (sender, args)
		if args.X >= chronoWidth-chronoBtnWidth then
			wMajFill(chrono);
		elseif args.Button==1 then
			ChronoStart(chrono, chrono.clickDelay);
			ChronoRefresh(chrono);
		else
			ChronoReset(chrono);
			ChronoRefresh(chrono);
		end
	end

	ChronoRedisplay(chrono);


	ChronoList:AddItem(bck);
end

-- Reclacule la taille
function ChronoSizeRefresh()
	wChronoParent:SetSize(chronoWidth,chronoStdHeight*2  + #ChronoConfig.chronos * chronoStdHeight);
	ChronoList:SetSize(chronoWidth, #ChronoConfig.chronos * chronoStdHeight);
end

-- Etat du combat...
BarInCombatStatus = { combat = false; dth = 0; };

-- Bascule le mode "inCombat" (c=mode combat)
function SetBarInCombat(c)
	BarInCombatStatus.dth = Turbine.Engine.GetGameTime();
	BarInCombatStatus.combat = c;
	if c then
		BarInCombat:SetForeColor(Turbine.UI.Color( 1, 0, 0 ));
	else
		BarInCombat:SetForeColor(Turbine.UI.Color( 1, 1, 1 ));
	end
	BarInCombatRefresh();
	ChronoCombat(c);	
end

function BarInCombatRefresh()
	if BarInCombatStatus.dth ~= 0 then
		local t;
		if BarInCombatStatus.combat then
			t= gLang.COMBATIN
		else
			t= gLang.COMBATOUT
		end
		BarInCombat:SetText(Includes.nb2hms(Turbine.Engine.GetGameTime() - BarInCombatStatus.dth) .. " " .. t  );
	end
end

-- Rafraichir tous les chronos
function ChronoRefreshAll()
	BarInCombatRefresh();
	for i = 1, #ChronoConfig.chronos do
		ChronoRefresh(ChronoConfig.chronos[i]);
	end
end

function ChronoRedisplay(chrono)
	if type(chrono.status) == "number" and chrono.status > 0 then
		if chrono.status==1 then
			ChronoGreen(chrono);
		elseif chrono.status==2 then
			ChronoOrange(chrono);
		elseif chrono.status==3 then
			ChronoRed(chrono);
		end
	else
		ChronoReset(chrono);
	end
end
function ChronoGreen(chrono)
	chrono.control:SetForeColor(Turbine.UI.Color( 0,0,1));
	chrono.bar:SetBackground(RESOURCESDIR.."greenCounter.tga");
	chrono.bar:SetVisible(true);
end
function ChronoRed(chrono)
	chrono.control:SetForeColor(Turbine.UI.Color( 0,0,1));
	chrono.bar:SetBackground(RESOURCESDIR.."redCounter.tga");
	chrono.bar:SetVisible(true);
end
function ChronoOrange(chrono)
	chrono.control:SetForeColor(Turbine.UI.Color( 0,0,1));
	chrono.bar:SetBackground(RESOURCESDIR.."orangeCounter.tga");
	chrono.bar:SetVisible(true);
end

-- chrono la definition du chrono du message
function ChronoRefresh(chrono)
	-- Si le controle n'est pas encore prsent, on ignore le refresh
	if chrono.control == nil then return end
	-- refresh le controle associ au chrono
	local delta = Turbine.Engine.GetGameTime() - chrono.dth ;
	-- Includes.Trace("d=".. delta .." s=" .. chrono.status);
	if chrono.status > 0 then
		if chrono.loop > 0 and delta >= chrono.loop then
			chrono.status = 1;
			ChronoGreen(chrono);
			chrono.dth = chrono.dth + chrono.loop - chrono.loopVal;
			delta = Turbine.Engine.GetGameTime() - chrono.dth;
			ChronoStartRelated(chrono,chronoAvecEvent.LOOP);
		end
		if chrono.alert >= 0 and delta >= chrono.alert and chrono.status < 3 then
			chrono.status = 3;
			ChronoRed(chrono);
			ChronoStartRelated(chrono,chronoAvecEvent.RED);
		elseif chrono.warn >= 0 and delta >= chrono.warn and chrono.status < 2 then
			chrono.status = 2;
			ChronoOrange(chrono);
			ChronoStartRelated(chrono,chronoAvecEvent.ORANGE);
		elseif chrono.reset > 0 and delta >= chrono.reset then
			ChronoReset(chrono);
			ChronoStartRelated(chrono,chronoAvecEvent.RESET);
		end
		if chrono.alert >= 0 then
			local sz = math.min(math.floor(chronoWidth * delta / chrono.alert),chronoWidth); 
			chrono.bar:SetSize( sz , 18 );
		end
		if (chrono.status==3 and chrono.isBlinkRed) or (chrono.status==2 and chrono.isBlinkOrange) then
			chrono.blinkStatus = not chrono.blinkStatus;
			chrono.bar:SetVisible(chrono.blinkStatus);
		end
		if chrono.lastDelta ~= delta then
			chrono.lastDelta = delta;
			if chrono.isCountdown and chrono.alert > 0 then
					delta = chrono.alert - delta; 
			end 
			chrono.control:SetText(Includes.nb2hms(delta) .. " " .. chrono.lbl  );
		end
	end
end


function ChronoCheckMessage(args)
	local m = args.Message;
	-- Includes.Trace(m);
	
	-- Recherche un chrono qui match
	for i = 1, #ChronoConfig.chronos do
		local chrono = ChronoConfig.chronos[i];
		-- Includes.Trace("Cmp: c="..chrono.search.. " vs m="..m);
		if (#chrono.search > 0) and (string.find(m,chrono.search,1,true) ~= nil) then
			-- Match....
			-- Includes.Trace("Found:"..chrono.search);
			if not chrono.searchOnce or not chrono.searchDone then
				chrono.searchDone = true;
				ChronoStart(chrono,chrono.searchDelay);
				ChronoRefresh(chrono);
			end
						
		end
	end
end

-- Lance un chronometre
function ChronoStart(chrono, delta)
	chrono.dth = Turbine.Engine.GetGameTime() - (delta or 0);
	chrono.lastDelta=-1;
	chrono.bar:SetBackground(RESOURCESDIR.."greenCounter.tga");
	chrono.bar:SetSize( 0 , 18 );
	chrono.bar:SetVisible(true);
	chrono.control:SetForeColor(Turbine.UI.Color( 0,0,1));
	chrono.status = 1;
	chrono.starting = true;
	ChronoStartRelated(chrono,chronoAvecEvent.START);
	chrono.starting = false;
end

-- lance les chronometre relatif a un event sur un chrono
function ChronoStartRelated(chrono, eventType)
	-- balaye tous les chronos INACTIF (status = 0) et les lance si match sur le lien de dpendance
	local n = 0;
	for i = 1, #ChronoConfig.chronos do
		local c = ChronoConfig.chronos[i];
		if c ~= chrono and not c.starting and c.demarreAvec==chrono.lbl and (c.avecEvent == eventType) and (not c.avecOnce or not c.avecDone) then
			c.avecDone = true;
			ChronoStart(c,c.avecDelay);
		end
	end
end

-- Reset un chronometre
function ChronoReset(chrono)
	chrono.dth = Turbine.Engine.GetGameTime()
	chrono.lastDelta=-1;
	chrono.bar:SetVisible(false);
	chrono.control:SetForeColor(Turbine.UI.Color( 1,1,1));
	chrono.status = 0;
	chrono.combatDone = false;
	chrono.avecDone = false;
	chrono.searchDone = false;
	chrono.control:SetText("0:00:00 " .. chrono.lbl  );
end

-- reset tous les chronos
function ChronoResetAll()
	for i = 1, #ChronoConfig.chronos do
		ChronoReset(ChronoConfig.chronos[i]);
	end
end

-- Positionne un chrono selon le mode combat qui change
function ChronoCombat(combat)
	if combat then
		-- Recherche un chrono qui match
		for i = 1, #ChronoConfig.chronos do
			local chrono = ChronoConfig.chronos[i];
			if chrono.demarreCombat and (not chrono.combatOnce or not chrono.combatDone) then
				chrono.combatDone = true;
				ChronoStart(chrono,chrono.combatDelay);
			end
		end
	else
		-- Recherche un chrono qui match
		for i = 1, #ChronoConfig.chronos do
			local chrono = ChronoConfig.chronos[i];
			if chrono.resetCombat then
				ChronoReset(chrono);
			end
		end
	end
end

-- Suppression d'un chronometre
function ChronoDelete(chrono)
	for i = 1, #ChronoConfig.chronos do
		if ChronoConfig.chronos[i] == chrono then
			ChronoList:RemoveItem(chrono.bck);
			table.remove(ChronoConfig.chronos,i);
			ChronoSizeRefresh();
			return;
		end
	end
end

-- Creation d'une nouvelle configuration "vide"
function ChronoNewConfiguration()
	local c = {name ="TBD mon amour"; chronos = {}; };
	table.insert(gSettings.configurations,c);
	ChronoActivateConfiguration(c);
	saveSettings();
end

-- Activation d'une configuration
function ChronoActivateConfiguration(c)
	ChronoConfig = c;
	ChronoActiveConfig:SetText(c.name);
	ChronoActiveConfig:SetEnabled(true);
	ChronoUpdateList();
	gSettings.lastConfigName=c.name;
end

-- Activation d'une configuration par son numero d'indexation
function ChronoActivateConfigurationById(id)
	ChronoActivateConfiguration(gSettings.configurations[id]);
end

-- Activation d'une configuration par son nom
function ChronoActivateConfigurationByName(n)
	for i=1, #gSettings.configurations do
		if gSettings.configurations[i].name==n then
			ChronoActivateConfiguration(gSettings.configurations[i]);
			return;
		end
	end
end

-- Suppression de la configuration active
function ChronoDeleteConfiguration(c)
	for i=1, #gSettings.configurations do
		if gSettings.configurations[i]==c then
			table.remove(gSettings.configurations,i);
			break;
		end
	end
	ChronoActiveConfig:SetText(gLang.CONFDELETED);
	ChronoActiveConfig:SetEnabled(false);
	ChronoConfig = { name = nil; chronos = {} };
	ChronoUpdateList();
end


-- Affiche le menu contextuel
function ChronoDisplayContextMenu()


	-- Construction du menu contextuel
	if ChronoContextMenu == nil then
		ChronoContextMenu = Turbine.UI.ContextMenu();
	end
	
	local menuItems = ChronoContextMenu:GetItems();
	menuItems:Clear();

	local configName = ChronoConfig.name;
	if configName==nil then 
		configName = "";
	else
		configName = " " .. UTF8_laquo .. configName .. UTF8_raquo;
	end

	local mi;

	mi = Turbine.UI.MenuItem(gLang.RESETALL,ChronoConfig.name ~= nil);
	mi.Click = function( sender, args)
		ChronoResetAll();
	end
	menuItems:Add(mi);

	menuItems:Add(Turbine.UI.MenuItem(" ",false));

	mi = Turbine.UI.MenuItem(gLang.NEWCHRONO,ChronoConfig.name ~= nil);
	mi.Click = function( sender, args)
		ChronoNew(nil);
	end
	menuItems:Add(mi);

	-- mi = Turbine.UI.MenuItem(gLang.SAVEPARAMS);
	-- mi.Click = function( sender, args)
	--	saveSettings();
	-- end
	-- menuItems:Add(mi);
	
	menuItems:Add(Turbine.UI.MenuItem(" ",false));

	mi = Turbine.UI.MenuItem(gLang.NEWCONF);
	mi.Click = function( sender, args)
		ChronoNewConfiguration();
	end
	menuItems:Add(mi);

	-- Balaye la liste des configurations dfinies actuellement
	for k=1, #gSettings.configurations do
		local config = gSettings.configurations[k];
		local eq = config ~= ChronoConfig;
		mi = Turbine.UI.MenuItem(gLang.USECONF .. " " .. UTF8_laquo ..config.name..UTF8_raquo, eq, not eq);
		mi.Click = function( sender, args)
			ChronoActivateConfigurationById(k);
		end
		menuItems:Add(mi);
	end

	menuItems:Add(Turbine.UI.MenuItem(" ",false));

	mi = Turbine.UI.MenuItem(gLang.IMPORTCONF..configName, ChronoConfig.name ~= nil);
	mi.Click = function( sender, args)
		ChronoImport();
	end
	menuItems:Add(mi);

	mi = Turbine.UI.MenuItem(gLang.EXPORTCONF..configName,ChronoConfig.name ~= nil);
	mi.Click = function( sender, args)
		ChronoExport();
	end
	menuItems:Add(mi);

	menuItems:Add(Turbine.UI.MenuItem(" ",false));

	mi = Turbine.UI.MenuItem(gLang.DELETECONF..configName, ChronoConfig.name ~= nil);
	mi.Click = function( sender, args)
		ChronoDeleteConfiguration(ChronoConfig);
	end
	menuItems:Add(mi);
	
	menuItems:Add(Turbine.UI.MenuItem(" ",false));

	mi = Turbine.UI.MenuItem(gLang.OPENTRACKER,ChronoConfig.name ~= nil);
	mi.Click = function( sender, args)
		wLogParent:SetVisible(true);
	end
	menuItems:Add(mi);

	menuItems:Add(Turbine.UI.MenuItem(" ",false));
	mi = Turbine.UI.MenuItem("Mode debug",true,gSettings.debug);
	mi.Click = function( sender, args)
		gSettings.debug = not gSettings.debug;
	end
	menuItems:Add(mi);

	if gSettings.debug then
		mi = Turbine.UI.MenuItem("Dump gConfig");
		mi.Click = function( sender, args)
			Includes.Trace("gSettings=" .. dump(gSettings));
		end
		menuItems:Add(mi);
	end
		
	ChronoContextMenu:ShowMenu();
end


