-- Gstion de la fienetre d'export

exportWidth = 450;
exportHeight= 510;


function wExportLabel(lbl,x,y,sz)
	local wL;
	wL = Turbine.UI.Label();
	wL:SetParent(wExportParent);
	wL:SetSize(sz,40);
	wL:SetPosition(x,y);
	wL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	wL:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	wL:SetText(lbl);
	return wL;
end


function DrawExportWindow()

	if wExportParent == nil then
		wExportParent = Turbine.UI.Lotro.Window();
		wExportParent:SetSize(exportWidth,exportHeight);
		wExportParent:SetPosition((Turbine.UI.Display:GetWidth()-exportWidth) / 2 ,(Turbine.UI.Display.GetHeight()-exportHeight) / 2 );

		Includes.Onscreen(wExportParent);

		wExportParent.Closing = function()
		end

		wExportParent.PositionChanged = function()
			-- gSettings.log.x = wLogParent:GetLeft();
			-- gSettings.log.y = wLogParent:GetTop();
		end


		ExportText = Turbine.UI.Lotro.TextBox();
		ExportText:SetParent(wExportParent);
		ExportText:SetSize(exportWidth-30,exportHeight-110);
		ExportText:SetPosition(10,70);
		ExportText:SetBackColor(Turbine.UI.Color( 0,0,0 ));
		ExportText:SetVisible(true);
		ExportText:SetMultiline(true);
		ExportText:SetSelectable(true);

		ExportVScroll = Turbine.UI.Lotro.ScrollBar();
		ExportVScroll:SetParent(wExportParent);
		ExportVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
		ExportVScroll:SetSize(8,ExportText:GetHeight());
		ExportVScroll:SetPosition((ExportText:GetLeft() + ExportText:GetWidth()),ExportText:GetTop());
		ExportVScroll:SetVisible(false);
		ExportVScroll:SetZOrder(200001);
		ExportText:SetVerticalScrollBar(ExportVScroll);

		ExportHScroll = Turbine.UI.Lotro.ScrollBar();
		ExportHScroll:SetParent(wExportParent);
		ExportHScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
		ExportHScroll:SetSize(ExportText:GetWidth(),8);
		ExportHScroll:SetPosition(ExportText:GetLeft(),(ExportText:GetTop() + ExportText:GetHeight()));
		ExportHScroll:SetVisible(false);
		ExportHScroll:SetZOrder(200000);
		ExportText:SetHorizontalScrollBar(ExportHScroll);
		
      	ImportButton = Turbine.UI.Lotro.Button();
      	ImportButton:SetPosition( exportWidth - 100 , exportHeight - 30 );
      	ImportButton:SetSize( 90, 20);
      	ImportButton:SetParent( wExportParent );
		ImportButton:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		ImportButton:SetText(gLang.IMPORTBTN);
		ImportButton.Click = function( sender, args)
	       Import(ExportText:GetText());
		end
		
		ImportHelp = wExportLabel(gLang.IMPORTHELP, 20, 30, exportWidth-30);
		ExportHelp = wExportLabel(gLang.EXPORTHELP, 20, 30, exportWidth-30);
	end
end

-- Import/export valeur numerique
function ExportValue(tag,val)
	local v;
	v = tonumber(val);
	if v==nil then 
		v=0;
	end 
	return tag.."="..v..";\n";
end
function ImportValue(v,min,max)
	local v = math.floor(tonumber(v));
	if min and v < min then v= min end
	if max and v > max then v = max end
	return v;
end

-- import/export valeur boolean
function ExportBoolean(tag,val)
	local v;
	if val==true then
		v="true"; 
	else
		v="false";
	end 
	return tag.."="..v..";\n";
end
function ImportBoolean(v)
	if v=="true" then
		return true;
	else
		return false;
	end
end

-- Chaione exportee = chaine pour lesquels & a t substitu par && et ; par &! et \n par &n
function ExportString(tag,str,s)

	if gSettings.debug then
		local x = "";
		for i=1, #str do
			x = x .. string.format("%d=%02x ",i,string.byte(str,i));
		end
	Includes.Trace("msg="..str.."hex="..x);
	end
	
	local v = string.gsub(str,"\\","\\\\");
	v = string.gsub(v,";","\\,");
	v = string.gsub(v,"\n","\\n");
	if s==true then
		v = string.gsub(v,"\t","\\t");
		v = string.gsub(v," ","\\ ");
		v = string.gsub(v,string.char(194)..string.char(160),"\\s");
	end
	
	return tag.."="..v..";\n";
end
function ImportString(s)
	return string.gsub(string.gsub(string.gsub(string.gsub(string.gsub(string.gsub(s,"\\s",string.char(194)..string.char(160)),"\\ "," "),"\\t","\t"),"\\n","\n"),"\\,",";"),"\\\\","\\");
end


-- Format d'import/export
EIConf ={
	-- t: s=string r=rawstring(ie escape spaces) m=-1,... z=0,... b=true|false
	{ e="name",			i="lbl", 			t="s", },
	{ e="comment",		i="comment", 		t="s", },
	{ e="text",			i="search", 		t="r", },
	{ e="orange",		i="warn", 			t="m", },
	{ e="red",			i="alert", 			t="m", },
	{ e="loop",			i="loop", 			t="z", },
	{ e="loopVal",		i="loopVal",		t="z", },
	{ e="reset",		i="reset", 			t="z", },
	{ e="related",		i="demarreAvec",	t="s", },
	{ e="combatOn",		i="demarreCombat",	t="b", },
	{ e="combatOff",	i="resetCombat",	t="b", },
	{ e="countdown",	i="isCountdown",	t="b", },
	{ e="orangeBlink",	i="isBlinkOrange",	t="b", },
	{ e="redBlink",		i="isBlinkRed",		t="b", },
	{ e="clickDelay",	i="clickDelay",		t="z", },
	{ e="combatDelay",	i="combatDelay",	t="z", },
	{ e="textDelay",	i="searchDelay",	t="z", },
	{ e="relatedDelay",	i="avecDelay",		t="z", },
	{ e="combatOnce",	i="combatOnce",		t="b", },
	{ e="textOnce",		i="searchOnce",		t="b", },
	{ e="relatedOnce",	i="avecOnce",		t="b", },
	{ e="relatedEvent",	i="avecEvent",		t="z", },
};	
function ImportSearch(n)
	for  i=1, #EIConf do
		if EIConf[i].e==n then
			return EIConf[i];
		end
	end
	return nil;
end

-- Exporte la configuration active
function ChronoExport()
	local exportText = ExportString("==="," ".. ChronoConfig.name.."(by "..gName..") ====").."\n";
	for i = 1, #ChronoConfig.chronos do
		local chrono = ChronoConfig.chronos[i];
		exportText = exportText .. "==== chrono ====;\n";
		
		for  f=1, #EIConf do
			local c = EIConf[f];
			if c.t=="s" then
				exportText = exportText .. ExportString(c.e, chrono[c.i],false);
			elseif c.t=="r" then
				exportText = exportText .. ExportString(c.e, chrono[c.i],true);
			elseif c.t=="z" or c.t=="m" then
				exportText = exportText .. ExportValue(c.e, chrono[c.i]);
			elseif c.t=="b" then
				exportText = exportText .. ExportBoolean(c.e, chrono[c.i]);
			end
		end
		exportText = exportText.."end=1;\n\n";
	end
	DrawExportWindow();
	wExportParent:SetText(gLang.EXPORTTITLE);
	ExportText:Focus();
	ExportText:SetText(exportText);
	ExportText:SetSelectable(true);
	ExportText:SetReadOnly(true);
	ExportText:SetSelectionStart(1);
	ExportText:SetSelectionLength(#exportText);
	ImportButton:SetVisible(false);
	ImportHelp:SetVisible(false);
	ExportHelp:SetVisible(true);
	wExportParent:SetVisible(true);
end

-- importation depuis la string de exporttext
function Import(conf)
	importChrono = nil;
    string.gsub(conf, "%s*(%w+)=([^;]*)", 
    	function (n,v)
    		-- Includes.Trace("Import <"..n.."="..v..">");
			if n=="exportFromConfig" then
				-- parametre exportFromConfig ignor
			elseif n=="name" then
				-- nouveau chrono  ajouter
				-- Si il y a un chrono en cours de definition... warning
				if importChrono ~= nil then
					Include.Trace("Warning: <end> tag missing, ".. importChrono.lbl .. " definition aborted");
				end
				importChrono = ChronoDefault();
				importChrono.lbl = ImportString(v);
    		elseif n=="end" then
				-- fin de definition
				if importChrono == nil then
    				Include.Trace("Warning: <end> tag without previous <name> tag, discarded");
				else
					ChronoInsert(importChrono);
					Includes.Trace(gLang.IMPORTED..importChrono.lbl);
					importChrono=nil;
				end
    		elseif importChrono ~= nil then
    			c = ImportSearch(n);
    			if c ~= nil then
    				-- Le champ est valide, on vrifie la valeur
    				if c.t=="s" or c.t=="r" then
    					importChrono[c.i] = ImportString(v);
    				elseif c.t=="m" or c.t=="z" then
    					importChrono[c.i] = ImportValue(v);
    				elseif c.t=="b" then
    					importChrono[c.i] = ImportBoolean(v);
    				else
    					Includes.Trace("Internal error <"..n.."="..v..">");
    				end
    			else
    				Includes.Trace("Warning:"..n.." is not a valid tag");
    			end
    		else
    			-- Les tag en dehors des elements name / end sont ignors
    		end
    		
  		end
  		);
	wExportParent:SetVisible(false);
	saveSettings();
end
-- IMporter dans la configuration active
function ChronoImport()
	DrawExportWindow();
	wExportParent:SetText(gLang.IMPORTTITLE);
	ExportText:SetText("");
	ExportText:SetSelectable(true);
	ExportText:SetReadOnly(false);
	ExportText:SetSelectionStart(1);
	ExportText:SetSelectionLength(0);
	ImportButton:SetVisible(true);
	ImportHelp:SetVisible(true);
	ExportHelp:SetVisible(false);
	wExportParent:SetVisible(true);
end
