-- Gstion de la fienetre de trace des logs.


logWidth = 450;
logHeight= 510;
logLineHeight= 17;


wLogLastTimeStamp = 0;
logging = false;

function DrawLogWindow()

	-- Parametres par defaut 
	if gSettings.log == nil then gSettings.log = {} end
	if gSettings.log.x == nil then gSettings.log.x = 100 end
	if gSettings.log.y == nil then gSettings.log.y = 100 end
	if gSettings.log.chatFilterMask == nil then gSettings.log.chatFilterMask = 100 end

	if wLogParent == nil then
		wLogParent = Turbine.UI.Lotro.Window();
		wLogParent:SetSize(logWidth,logHeight);
		wLogParent:SetPosition(gSettings.log.x,gSettings.log.y);
		wLogParent:SetText(_LANG.LOGTITLE[gSettings.lang]);
		wLogParent:SetVisible(false);

		Includes.Onscreen(wLogParent);

		wLogParent.Closing = function()
			gSettings.log.visible = false;
		end

		wLogParent.PositionChanged = function()
			gSettings.log.x = wLogParent:GetLeft();
			gSettings.log.y = wLogParent:GetTop();
		end


		LogList = Turbine.UI.ListBox();
		LogList:SetParent(wLogParent);
		LogList:SetSize(logWidth-30,logHeight-110);
		LogList:SetPosition(10,70);
		LogList:SetBackColor(Turbine.UI.Color( 0,0,0 ));
		LogList:SetVisible(true);

		LogList.SelectedIndexChanged = function ( sender, args)
			-- Includes.Trace("MouseClick sender"..dump(sender));
			-- Includes.Trace("args"..dump(args));
			local si = LogList:GetSelectedItem();
			if si == nil then return end
			-- Ajout d'un chrono bas sur le message slectionn
			local s = si:GetText();
			local d = string.find (s, ") ",1,true);
			Includes.Trace(string.sub(s,d+2));
			Windows.ChronoNew(string.sub(s,d+2));
		end
	
	
		LogVScroll = Turbine.UI.Lotro.ScrollBar();
		LogVScroll:SetParent(wLogParent);
		LogVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
		LogVScroll:SetSize(8,LogList:GetHeight());
		LogVScroll:SetPosition((LogList:GetLeft() + LogList:GetWidth()),LogList:GetTop());
		LogVScroll:SetVisible(false);
		LogVScroll:SetZOrder(200001);
		LogList:SetVerticalScrollBar(LogVScroll);

		LogHScroll = Turbine.UI.Lotro.ScrollBar();
		LogHScroll:SetParent(wLogParent);
		LogHScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
		LogHScroll:SetSize(LogList:GetWidth(),8);
		LogHScroll:SetPosition(LogList:GetLeft(),(LogList:GetTop() + LogList:GetHeight()));
		LogHScroll:SetVisible(false);
		LogHScroll:SetZOrder(200000);
		LogList:SetHorizontalScrollBar(LogHScroll);
		
		LogRecording = Turbine.UI.Lotro.CheckBox();
		LogRecording:SetParent(wLogParent);
		LogRecording:SetSize(200,20);
		LogRecording:SetPosition(25,30);
		LogRecording:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		LogRecording:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		LogRecording:SetText(" " .. gLang.RECORD);
		LogRecording.CheckedChanged = function (sender, args)
			SetLogging(not logging);
		end

		LogClear = Turbine.UI.Lotro.Button();
		LogClear:SetParent(wLogParent);
		LogClear:SetSize(100,20);
		LogClear:SetPosition(225,30);
		LogClear:SetText(" " .. gLang.LOGCLEAR);
		LogClear.Click = function (sender, args)
			LogList:ClearItems();
		end

		-- Construction du menu contextuel pour la configuration
		LogContextMenu = Turbine.UI.ContextMenu();
		
		local menuItems = LogContextMenu:GetItems();
		
		-- Ajoute les diffrents types de chat possible
		for k, v in pairs (Turbine.ChatType) do
			local mi;
			if gSettings.debug then
				mi = Turbine.UI.MenuItem(string.format("[%08X] %s",v,k),true,Turbine.ChatType);
			else
				mi = Turbine.UI.MenuItem(k,true,Turbine.ChatType);
			end
			mi.Click = function( sender, args)
				Includes.Trace(".............. A  FAIRE !!!!!!!!!! chatType=" .. k .. " val=" .. v);
			end
			menuItems:Add(mi);
		end	
      	
		LogFilters = Turbine.UI.Lotro.Button();
		LogFilters:SetParent(wLogParent);
		LogFilters:SetSize(100,20);
		LogFilters:SetPosition(325,30);
		LogFilters:SetText(" " .. gLang.FILTERPRM);
		LogFilters.Click = function (sender, args)
			LogContextMenu:ShowMenu();
		end
		
		LogInfo = Turbine.UI.Label();
		LogInfo:SetParent(wLogParent);
		LogInfo:SetSize(400,20);
		LogInfo:SetPosition(25,55);
		LogInfo:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		LogInfo:SetText(gLang.HELPCLICK);

	end
end




function SetLogging(onOff)
	if onOff then
		logging=true;
		Turbine.Shell.WriteLine(gSettings.pluginName .. ": ".. gLang.LOGON );
	else
		Turbine.Shell.WriteLine(gSettings.pluginName .. ": ".. gLang.LOGOFF);
		logging=false;
	end
end



-- Ajout un log dans la fenetre, si logging actif
-- Channel : nom string du cnal de discussion
-- args.Sender, args.Messsage, args.ChatType
function Log(args) 

	if logging == true then
		local m = args.Message;
		if m==nil then m="empty message" end
		local s = args.Sender;
		if s == nil then s = "?" end
		
		-- Retourne le tye litteral du chattype
		local chatChannel = nil;
		for k, v in pairs (Turbine.ChatType) do
			if v == args.ChatType then chatChannel = k; break; end;
		end

		if chatChannel == nil then
			-- le chatChannel ne peut etre traduit en litral 
			chatChannel=args.ChatType
			if chatChannel == nil then 
				-- pas de chatChannel !!
				chatChannel="?"; 
				Includes.Trace(dump(args));
			else
				-- un chatChannel exprim en hexa
				chatChannel=string.format("%08X",chatChannel);
			end
		end
		-- Filtrage par rapport aux flags actifs
		
		-- if args.ChatType ~= 0 and bit32.band(args.ChatType,gSettings.log.chatFilterMask) == 0 then
			-- Aucun flag ne match le message
		--	return;
		-- end
		-- log l'element
		local hms = Includes.dth2hms(Turbine.Engine.GetDate());
		local txt = hms .. " ("..chatChannel ..","..s..") ".. m;
		local lbl = Turbine.UI.Label();
		lbl:SetSize(LogList:GetWidth() * 3,logLineHeight);
		-- lbl:SetHeight(logLineHeight);
		lbl:SetFont(Turbine.UI.Lotro.Font.Verdana12);
		lbl:SetForeColor(Turbine.UI.Color( 0.9,0,0));
		lbl:SetBackColor(Turbine.UI.Color( 0.1,0,0));
		lbl:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		lbl:SetSelectable(true);
		lbl:SetMultiline(false);
		lbl:SetText(txt);
--		lbl.MouseHover = function(sender, args)
--			lbl:SetBackColor(Turbine.UI.Color( 0.8,0.8,0.8));
--		end
--		lbl.MouseLeave = function(sender, args)
--			lbl:SetBackColor(Turbine.UI.Color( 0.1,0,0));
--		end
		
		LogList:AddItem(lbl);
	end
end


